<?

/***************************************************************************
*                            Dolphin Smart Community Builder
*                              -------------------
*     begin                : Mon Mar 23 2006
*     copyright            : (C) 2007 BoonEx Group
*     website              : http://www.boonex.com
* This file is part of Dolphin - Smart Community Builder
*
* Dolphin is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the
* License, or  any later version.
*
* Dolphin is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with Dolphin,
* see license.txt file; if not, write to marketing@boonex.com
***************************************************************************/

bx_import('BxDolModuleTemplate');

class BxFdbTemplate extends BxDolModuleTemplate {
    var $oPaginate;
    
	/**
	 * Constructor
	 */
	function BxFdbTemplate(&$oConfig, &$oDb) {
	    parent::BxDolModuleTemplate($oConfig, $oDb);

	    $this->_aTemplates = array('comments');
	}
	
	function init(&$oDb) {
        $this->oPaginate = new BxDolPaginate(array(
        	'page_url' => 'javascript:void(0);',
            'start' => 0,
            'per_page' => $this->_oConfig->getPerPage(),
            'per_page_step' => 2,
            'per_page_interval' => 3,
            'on_change_page' => $this->_oConfig->getJsObject() . '.changePage({start}, {per_page})'
        ));
	}
	function displayAdminBlock($aParams) {
	    $oSearchResult = $aParams['search_result_object'];
	    unset($aParams['search_result_object']);
	     
	    $aButtons = array(
            'feedback-approve' => _t('_feedback_lcaption_approve'),
            'feedback-reject' => _t('_feedback_lcaption_reject'),
            'feedback-delete' => _t('_feedback_lcaption_delete')
        );
	    $aResult = array(
            'include_css' => $this->addCss(array('view.css', 'cmts.css'), true),
	    	'include_js_content' => $this->getViewJs(),
            'filter' => $oSearchResult->showAdminFilterPanel($aParams['filter_value'], 'news-filter-txt', 'news-filter-chb', 'news-filter'),
            'content' => $this->displayList($aParams),
            'control' => $oSearchResult->showAdminActionsPanel('feedback-view-admin', $aButtons, 'feedback-ids')
        );
                
	    return $this->addJs(array('main.js'), true) . $this->parseHtmlByName('admin.html', $aResult);
	}
	function displayBlock($aParams) {
		$bShowEmpty = isset($aParams['show_empty']) ? $aParams['show_empty'] : true;
		
        $aResult = array(
        	'include_js_content' => $this->getViewJs(),
            'content' => $this->displayList($aParams),
        );
		
        if(!$bShowEmpty && empty($aResult['content']))
        	return ""; 

        $this->addJs('main.js');
        $this->addCss(array('view.css'));
	    return $this->parseHtmlByName('view.html', $aResult);
	}
	function displayList($aParams) {
	    $sSampleType = $aParams['sample_type'];
	    $iViewerId = isset($aParams['viewer_id']) ? (int)$aParams['viewer_id'] : 0;
	    $iViewerType = $aParams['viewer_type'];
	    $iStart = isset($aParams['start']) ? (int)$aParams['start'] : -1;
	    $iPerPage = isset($aParams['count']) ? (int)$aParams['count'] : -1;
	    $bShowEmpty = isset($aParams['show_empty']) ? $aParams['show_empty'] : true;
	    
	    
	    $aFeedback = $this->_oDb->getFeedback($aParams);
	    if(empty($aFeedback)) 
	    	return $bShowEmpty ? MsgBox(_t('_feedback_msg_no_results')) : "";
	    
	    //--- Language translations ---//
        $sLKLinkApprove = _t('_feedback_lcaption_approve');
        $sLKLinkReject = _t('_feedback_lcaption_reject');        
        $sLKLinkEdit = _t('_feedback_lcaption_edit');
        $sLKLinkDelete = _t('_feedback_lcaption_delete');
        
        $sJsMainObject = $this->_oConfig->getJsObject();

        $aResult['bx_repeat:entries'] = array();        
	    foreach($aFeedback as $aEntry) {
	        $sVotes = "";

	        if($this->_oConfig->isVotesAllowed() && $aEntry['is_vote'] == 1) {
                $oVotes = new BxFdbVoting($this->_oConfig->getVotesSystemName(), $aEntry['id']);
                $sVotes = $oVotes->getJustVotingElement(0, $aEntry['id']);
	        }
	        
	        $aResult['bx_repeat:entries'][] = array(
                'id' => $this->_oConfig->getSystemPrefix() . $aEntry['id'],
                'author_icon' => get_member_icon($aEntry['author_id'], 'left'),
                'caption' => str_replace("$", "&#36;", $aEntry['caption']),
                'class' => !in_array($sSampleType, array('view')) ? ' feedback-text-snippet' : '',
                'date' => getLocaleDate($aEntry['date']),
                'content' => str_replace("$", "&#36;", $aEntry['content']),
                'link' => BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . 'view/' . $aEntry['uri'],
                'voting' => $sVotes,
                'bx_if:checkbox' => array(
                    'condition' => $iViewerType == BX_TD_VIEWER_TYPE_ADMIN && isset($aParams['admin_panel']) && $aParams['admin_panel'],
                    'content' => array(
                        'id' => $aEntry['id']
                    ),
                ),
                'bx_if:status' => array(
                    'condition' => ($iViewerType == BX_TD_VIEWER_TYPE_MEMBER && $iViewerId == $aEntry['author_id']) || $iViewerType == BX_TD_VIEWER_TYPE_ADMIN,
                    'content' => array(
                        'status' => _t('_feedback_status_' . $aEntry['status'])
                    ),
                ),
                'bx_if:edit_link' => array (
                    'condition' => ($iViewerType == BX_TD_VIEWER_TYPE_MEMBER || $iViewerType == BX_TD_VIEWER_TYPE_ADMIN) && $iViewerId == $aEntry['author_id'],
                    'content' => array(
                        'edit_link_url' => BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . 'post/' . $aEntry['uri'],
                        'edit_link_caption' => $sLKLinkEdit,
                    )
                )                
            );	        
	    };
        
	    $aResult['paginate'] = '';
	    if(!in_array($sSampleType, array('id', 'uri', 'view', 'search_unit'))) {
    	    if(!empty($sSampleType)) {	        
    	        $this->oPaginate->setCount($this->_oDb->getCount(array('sample_type' => $sSampleType)));
                $this->oPaginate->setOnChangePage($this->_oConfig->getJsObject() . '.changePage({start}, {per_page}, \'' . $sSampleType . '\')');
    	    }
    	    $aResult['paginate'] = $this->oPaginate->getPaginate($iStart, $iPerPage);
	    }

	    return $this->parseHtmlByName('list.html', $aResult);
	}
	/**
	 * Prepare JavaScript paramaters.
	 */
	function getViewJs() {
	    $sJsMainObject = $this->_oConfig->getJsObject();
        ob_start();
?>
        var <?=$sJsMainObject; ?> = new BxFeedbackMain({
            sSystem: '<?=$this->_oConfig->getSystemPrefix(); ?>',
            sActionUrl: '<?=BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri(); ?>',
            sObjName: '<?=$sJsMainObject; ?>',
            sAnimationEffect: '<?=$this->_oConfig->getAnimationEffect(); ?>',
            iAnimationSpeed: '<?=$this->_oConfig->getAnimationSpeed(); ?>'
        });        
<?
		return ob_get_clean();
	}
}
?>